; This function is owned by Onan Farabi.
; For commercial purpose please contact me.

PosCount proto :dword,:dword,:dword,:dword

GetPosLine proto :dword,:dword,:dword,:dword
GetDeltaXY proto :dword,:dword,:dword,:dword
GetHypotenusa proto :dword,:dword
GetPosRound proto :dword,:dword
GetPosRound2 proto :dword,:dword
UMGetPosRound proto :dword,:dword
GetDegree proto :dword,:dword
GetScale proto :dword,:dword
GetPosX proto :dword,:dword
GetSin proto :dword
GetCos proto :dword
GetTan proto :dword
GetFG proto :dword,:dword

FPGetSin proto :dword
FPGetCos proto :dword
FPGetTan proto :dword


RotatePoint proto :dword,:dword,:dword,:dword

fGrad proto :dword,:dword,:dword
IsInsideRect proto :dword,:dword,:dword,:dword,:dword,:dword
IsInsideCircle proto :dword,:dword,:dword

aTan2 proto :dword,:dword
Deg2Rad proto :dword
Rad2Deg proto 


CenterScreen proto :dword,:dword
To3D proto :dword,:dword,:dword
CreateLine proto :dword,:Dword,:dword,:dword
GetLine3D proto :dword,:Dword
GetCountLine3D proto
ResetLine proto 

GetLine3DAll proto :dword,:dword
SetLine3DAll proto :dword,:Dword

MirrorPosA proto :dword,:dword,:dword
Phase1 proto

SetClockCount proto 
AddClockCount proto :dword
GetClockCount proto

FramePosition proto dwInd:dword,y:dword 
UMGetSqrt proto value:dword



line3D struct
	x dword 0
	y dword 0
	z dword 0
	color dword 0
line3D ends

.data?
	SCTbl_sin dword ?
	SCTbl_cos dword ?
	SCTbl_tan dword ?
	
	FPU_SinTable dword ?
	FPU_CosTable dword ?
	FPU_TanTable dword ?

	
	Line_Table dword ?
	
	SCR_TBL dword ?
	
	nLPtr dword ?
	nLLimit dword ?
	
	VP dword ?
	x_res dword ?
	y_res dword ?
	
	sqrt_tbl dword ?
	angle_tbl dword ?
.data
	SinTable db 'SinCosTable.frb',0
.code



IsInsideCircle proc radius:dword,nDX:dword,nDY:dword
	; Not completed yet
	invoke GetHypotenusa,nDX,nDY
	
	.if eax<radius
		xor eax,eax
		inc eax
	.else
		xor eax,eax
	.endif
	
	ret
IsInsideCircle endp

FramePosition proc uses esi edi dwInd:dword,h:dword
	
	xor edx,edx
	mov eax,h
	mov ecx,dwInd
	
	mul ecx
	
	
	
	ret
FramePosition endp ; eax = position heigth 

RotatePoint proc delta:dword,xAng:dword,yAng:dword,zAng:dword
	LOCAL x,y,z:dword
	
	xor ecx,ecx
	mov x,ecx
	mov y,ecx
	mov z,ecx
	; rotate around z axis (x y)
	invoke UMGetPosRound,delta,zAng
	mov x,edx						; cos
	invoke UMGetPosRound,delta,zAng
	mov y,eax						; sin
	
	; rotate around x axis (y z)
	invoke UMGetPosRound,y,xAng
	mov y,edx						; y is delta*cos(xang)
	invoke UMGetPosRound,delta,xAng
	mov z,eax						; z is delta*sin(xang)
	
	; rotate around y axis (x z)
	invoke UMGetPosRound,z,yAng
	mov z,edx						; cos
	invoke UMGetPosRound,x,yAng
	mov x,eax						; sin
	
	mov edx,x
	mov eax,y
	mov ecx,z
	
	ret
RotatePoint endp ; edx =x eax=y ecx=z

CreateSinTable proc uses esi 
	LOCAL mem:Dword
	LOCAL deg:dword
	
	invoke mAlloc,3600*4
	mov mem,eax
	mov esi,eax					; 1 Clock cycle
	xor ecx,ecx					; 1 Clock cycle
	mov deg,ecx					; 1 Clock cycle
		
	@@:
	finit						; 17 Clock cycle
	pushad
	invoke Deg2Rad,deg			; 104 Clock cycle
	popad
	fsin
	fstp dword ptr[esi+ecx*4]
	inc ecx
	inc deg
	cmp deg,3600
	jle @b
	
	mov eax,mem	
	
	ret
CreateSinTable endp

CreateCosTable proc uses esi
	LOCAL mem:Dword
	LOCAL deg:dword
	
	invoke mAlloc,3600*4
	mov mem,eax
	mov esi,eax					; 1 Clock cycle
	xor ecx,ecx					; 1 Clock cycle
	mov deg,ecx					; 1 Clock cycle

	@@:
	finit						; 17 Clock cycle
	pushad
	invoke Deg2Rad,deg			; 104 Clock cycle
	popad
	fcos
	fstp dword ptr[esi+ecx*4]
	inc ecx
	inc deg
	cmp deg,3600
	jle @b	

	mov eax,mem	
	
	ret
CreateCosTable endp

CreateTanTable proc uses esi
	LOCAL mem:Dword
	LOCAL deg:dword
	
	invoke mAlloc,3600*4
	mov mem,eax
	mov esi,eax					; 1 Clock cycle
	xor ecx,ecx					; 1 Clock cycle
	mov deg,ecx					; 1 Clock cycle

	@@:
	finit						; 17 Clock cycle
	pushad
	invoke Deg2Rad,deg			; 104 Clock cycle
	popad
	fptan
	fstp dword ptr[esi+ecx*4]
	inc ecx
	inc deg
	cmp deg,3600
	jle @b
	
	mov eax,mem	
	ret
CreateTanTable endp


Phase1 proc uses esi 	; 28.8 Kbyte needed
	LOCAL deg,sin,cos,tan,sqrt:dword
	
	invoke CreateSinTable
	mov FPU_SinTable,eax
	invoke CreateCosTable
	mov FPU_CosTable,eax
	invoke CreateTanTable
	mov FPU_TanTable,eax

	
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,28800+14400
	mov SCTbl_sin,eax
	
	
	mov esi,eax					; 1 Clock cycle
	xor ecx,ecx					; 1 Clock cycle
	mov deg,ecx					; 1 Clock cycle
	
	mov edx,3600				; 1 Clock cycle
	shl edx,2					; 2 Clock cycle
	
	
	@@:
	finit						; 17 Clock cycle
	pushad
	invoke Deg2Rad,deg			; 104 Clock cycle
	popad
	fsincos						; 365 Clock cycle
	
	push 1024
	fimul dword ptr[esp]	
	fistp dword ptr[esp]			
	pop sin
	push 1024
	fimul dword ptr[esp]
	fistp dword ptr[esp]					
	pop cos
	
	mov eax,sin					; 1 Clock cycle
	mov dword ptr[esi],eax		; 1 Clock cycle
	mov eax,cos					; 1 Clock cycle
	mov dword ptr[esi+edx],eax	; 1 Clock cycle
	
	add deg,1					; 3 Clock cycle
	add esi,4					; 1 Clock cycle
	add ecx,4					; 1 Clock cycle
	cmp deg,3600				; 2 Clock cycle
	jl @b						; 3 Clock cycle
								; 513 Clock cycle Each loop
	; 1846800 Clock cycle total loop
	; 1846806 Clock cycle
	mov esi,SCTbl_sin
	add esi,14400
	mov SCTbl_cos,esi
	
	mov esi,SCTbl_sin
	add esi,28800
	mov SCTbl_tan,esi
	;Tan
	mov edx,3600				; 1 Clock cycle
	shl edx,2					; 2 Clock cycle
	
	xor ecx,ecx
	mov deg,ecx
	
	@@:
	finit						; 17 Clock cycle
	pushad
	invoke Deg2Rad,deg			; 104 Clock cycle
	popad
	fptan						; 273 Clock cycle
	fxch 
	push 1024
	fimul dword ptr[esp]
	fistp dword ptr[esp]
	pop eax
	
	push tan
	pop [esi]
	add deg,1					; 3 Clock cycle
	add esi,4					; 1 Clock cycle
	add ecx,4					; 1 Clock cycle
	cmp deg,3600				; 2 Clock cycle
	jl @b						; 3 Clock cycle
	
	
	invoke mAlloc,768*4
	mov esi,eax
	mov SCR_TBL,esi
	
	mov ecx,768
	xor eax,eax
	xor edx,edx
	@@:
	mov [esi+edx*4],eax
	add eax,1024
	inc edx
	dec ecx
	jns @b
	
	invoke GlobalAlloc,GMEM_ZEROINIT or GMEM_FIXED,1024
	mov sqrt_tbl,eax
	
	; table function 256.0 * sqrt( i/256.0 );
	mov ecx,256
	xor edx,edx
	@@:
	push ecx
		push edx
			fild dword ptr[esp]
			push 256
				fidiv dword ptr[esp]
				fsqrt
					push 256
						fimul dword ptr[esp]
						fistp dword ptr[esp]
					pop sqrt
			pop edx
		pop edx
		
	push sqrt
	pop ecx
	
	mov [eax+edx],cl
	
	pop ecx
	inc edx
	dec ecx
	jns @b
	
	invoke mAlloc,3600*4
	mov angle_tbl,eax
	
	mov esi,eax
	mov ecx,3600
	xor edx,edx
	@@:
	push edx
		fild dword ptr[esp]
		fstp dword ptr[esp]
	pop [esi+edx*4]
	inc edx
	dec ecx
	jnz @b
	
	
	ret
Phase1 endp

CoolDownSystem proc uses esi
	
	invoke GlobalFree,SCTbl_sin
	invoke GlobalFree,sqrt_tbl
	invoke GlobalFree,angle_tbl
	
	
	ret
CoolDownSystem endp

MirrorPos proc x:dword,y:dword,reg:dword
	
	mov edx,x
	mov eax,y
	
	cmp reg,0
	jz brs
;	cmp reg,1
;	jz rev_plus_plus
	cmp reg,1
	jz min_plus
;	cmp reg,3
;	jz rev_min_plus
	cmp reg,2
	jz min_min
;	cmp reg,5
;	jz rev_min_min
	cmp reg,3
	jz plus_min
;	cmp reg,7
;	jz rev_plus_min
	ret
	min_plus:
		neg edx
		ret
	min_min:
		neg edx
		neg eax
		ret
	plus_min:
		neg eax
		ret
	rev_min_plus:
		neg edx
		xchg eax,edx
		ret
	rev_min_min:
		neg edx
		neg eax
		xchg eax,edx
		ret
	rev_plus_min:
		neg eax
		xchg eax,edx
		ret
	rev_plus_plus:
		xchg eax,edx
		ret
	brs:
	xor eax,eax
	ret
MirrorPos endp

PosCount proc x:dword,y:dword,maxX:dword,maxY:dword

	
	mov eax,maxY			; 1 clock cycle
	cmp y,eax				; 2 clock cycle
	jae brs					; 1 clock cycle
	mov eax,maxX			; 1 clock cycle
	cmp x,eax				; 2 clock cycle
	jae brs					; 1 clock cycle
	xor ecx,ecx
	cmp x,ecx
	jl brs
	cmp y,ecx
	jl brs
		mov ecx,y
	;	mov eax,maxX		; 1 clock cycle eax:=maxX
	;	mul y				; 42 clock cyclee ax:=maxX*y
		shl ecx,10
		mov eax,ecx
		add eax,x			; 2 clock cycle eax:=(MaxX * Y)+x
		ret					; 1 clock cycle
		; 54 clock cycle
	brs:
	xor eax,eax
	dec eax
	ret
PosCount endp

PosCount2 proc uses esi edi x:dword,y:dword
	
	mov esi,SCR_TBL
	mov eax,y
	cmp eax,768
	ja error
	xor ecx,ecx
	cmp eax,ecx
	jl error
		mov eax,[esi+eax*4]
		mov edx,x
		cmp edx,1024
		jae error
		cmp edx,ecx
		jl error
			add eax,edx
			ret
	error:
	xor eax,eax
	dec eax
	ret
PosCount2 endp

GetPosLine proc nDX:dword,nDY:dword,hyp:dword,nPos:dword
	LOCAL x,y:dword
	
;	fild nDX		
;	fidiv hyp		
;	fimul nPos		
;	fistp x			
	
	; (nPos*nDX)/hyp
	xor edx,edx		; 1
	xor eax,eax		; 1
	
	mov eax,nDX		; 1
	imul nPos		; 42
	idiv hyp		; 42
	mov x,eax		; 1
		
;	fild nDY		
;	fidiv hyp		
;	fimul nPos		
;	fistp y			
	
	; (nPos*nDY)/hyp
	
	xor edx,edx		; 1
	xor eax,eax		; 1
	
	mov eax,nDY		; 1
	imul nPos		; 42
	idiv hyp		; 42
	mov y,eax		; 1
	
	mov edx,x		
	mov eax,y		
	
	ret
GetPosLine endp		; Result on edx:eax

GetDeltaXY proc x:dword,y:dword,x2:dword,y2:dword
	
	mov edx,x2
	sub edx,x
	mov eax,y2
	sub eax,y
	
	ret
GetDeltaXY endp		; Result on edx:eax

GetHypotenusa proc nDX:dword,nDY:dword
	LOCAL res:dword
	
	xor edx,edx
	mov eax,nDY
	mul eax
	
	mov res,eax
	
	xor edx,edx
	mov eax,nDX
	mul eax
	
	add res,eax
	fild res
	fsqrt
	fistp res
;	invoke GetSqrt,res
	mov eax,res
	
	ret
GetHypotenusa endp	;

GetHypotenusa2 proc nDX:dword,nDY:dword
	LOCAL res:dword
	
	xor edx,edx
	mov eax,nDX
	mul eax
	mov res,eax
	
	xor edx,edx
	mov eax,nDY
	mul eax
	add res,eax
	
	invoke UMGetSqrt,res
	
	ret
GetHypotenusa2 endp

GetDegree proc nDX:dword,nDY:dword
	
	invoke aTan2,nDX,nDY
	invoke Rad2Deg
	
	ret
GetDegree endp				; eax=(atan(dy,dx)) 

fGrad proc x:dword,nMaxx:dword,nNum:dword
	
	xor edx,edx		; 1
	mov eax,nNum	; 2
	mul x			; 42
					
	div nMaxx		; 40
	; 85 clock cycle
	
	ret
fGrad endp  				; eax result	; edx the rest;

IsInsideRect proc mX:dword,mY:dword,x:dword,y:dword,l:dword,t:dword
	
	mov eax,x
	mov edx,y
	
	cmp mX,eax
	jl brs
	cmp mY,edx
	jl brs
		add eax,l
		add edx,t
		cmp mX,eax
		ja brs
			cmp mY,edx
			ja brs
		xor eax,eax
		inc eax
		ret
	brs:
	xor eax,eax
	dec eax
	ret
IsInsideRect endp 			; Result eax=1 if on the rect

aTan2 proc	nDX:dword, nDY:dword
	
	fild nDX				;
	fild nDY				;
	fpatan
	
	ret
aTan2 endp					; result at st(0)

Deg2Rad proc deg:dword								; 104 Clock cycle
	
	fldpi					; Load Phi							8  Clock cycle
	push 180				; Push 180 degree					1  Clock cycle
	fidiv dword ptr[esp]	; Div it with #180					86 Clock cycle
	pop eax					; eax are Junk						4  Clock cycle
	
	fild deg				; Rot								
	push 10					;									1  Clock cycle
	fidiv dword ptr[esp]	; Rot/#100, We got float here		
	pop eax					; eax are Junk						4  Clock cycle
	
	fmul st,st(1)			; Mul, a = (rot/#100) * (Phi/180)	
	
	ret
Deg2Rad endp				; Result at FPU

Rad2Deg proc 				; Source must be at st(0)
	
	push 3600
		fldpi
		fidivr dword ptr[esp]
		fmul st,st(1)
		fistp dword ptr[esp]
	pop eax
	
	ret
Rad2Deg endp

To3D proc x:dword,y:dword,z:dword
	LOCAL f,g,sx,sy,sz:dword
	LOCAL xc,yc:dword
	; sx=x*f/z + 1/2 nMaxX
	; sy=y*g/z + 1/2 nMaxY
	; f=w/tan(a)
	; g=h/tan(b)
	
	; Not bad. This function now shorter and faster.
	
	cmp z,0
	jnle @f
		;inc z
		ret
	@@:
;	add z,500
	
	invoke CenterScreen,x_res,y_res 
	mov xc,edx							
	mov yc,eax							
	
	xor edx,edx
	mov eax,x
	mov ecx,VP
	imul ecx
	idiv z
	add eax,xc
	mov xc,eax
	
	xor edx,edx
	mov eax,y
	mov ecx,VP
	imul ecx
	idiv z
	add eax,yc
	mov yc,eax
	
	mov edx,xc
	mov eax,yc
	
	
	
	ret
To3D endp											; 16213/10000000

SetVP proc ViewPoint:dword

	
	push ViewPoint
	pop VP	
	
	ret
SetVP endp

SetResolution proc x:dword,y:dword
	
	push x
	pop x_res
	push y
	pop y_res
	
	ret
SetResolution endp

CenterScreen proc nMaxX:dword,nMaxY:dword			; 8 Clock cycle
			
	mov edx,nMaxX						; 1 Clock cycle
	mov eax,nMaxY						; 1 Clock cycle
	
	shr edx,1							; 3 Clock cycle
	shr eax,1							; 3 Clock cycle
	; 8 Clock cycle
	
	ret
CenterScreen endp


FPUMGetPosRound proc delta:dword,nRot:dword
	LOCAL r_sin:dword,r_cos:dword
	LOCAL divider:dword
	
	invoke FPGetSin,nRot
	mov r_sin,eax
	invoke FPGetCos,nRot
	mov r_cos,eax
	
	fld dword ptr[delta]
	fmul dword ptr[r_sin]
	fstp dword ptr[r_sin]
	
	fld dword ptr[delta]
	fmul dword ptr[r_cos]
	fstp dword ptr[r_cos]
	
	
	mov edx,r_cos
	mov eax,r_sin
	
	
	ret
FPUMGetPosRound endp									; edx= cos(nRot)*delta, eax= sin(nRot)*Delta

UMGetPosRound proc uses esi delta:dword,deg:dword 	; 138 Clock cycle
	LOCAL r_sin,r_cos:dword
	
	
	cmp deg,3600
	jl @f
		sub deg,3600
	@@:
	cmp deg,0
	jae @f
		add deg,3600
	@@:
	
	invoke GetSin,deg		
;	push eax				
;		fld dword ptr[esp]	
;	pop eax					
;	fimul delta				
;	fistp r_sin
					
	xor edx,edx
	mov ecx,delta
	imul ecx
;	mov ecx,1000
;	idiv ecx
	shr eax,10
	mov r_sin,eax
	
	invoke GetCos,deg		
;	push eax				
;		fld dword ptr[esp]	
;	pop eax					
;	fimul delta				
;	fistp r_cos
		
	xor edx,edx
	mov ecx,delta
	imul ecx
;	mov ecx,1000
;	idiv ecx
	shr eax,10
	mov r_cos,eax
	
	mov edx,r_sin			
	mov eax,r_cos			
							
	
	ret
UMGetPosRound endp


GetSin proc uses esi deg:dword						; 3 Clock cycle
	
	mov esi,SCTbl_sin					; 1 Clock cycle
	mov ecx,deg						; 1 Clock cycle
	mov eax,dword ptr[esi+ecx*4]	; 1 Clock cycle
	
	ret
GetSin endp

GetCos proc uses esi deg:dword						; 3 Clock cycle
	
	mov esi,SCTbl_cos					; 1 Clock cycle
	mov ecx,deg						; 1 Clock cycle
	mov eax,dword ptr[esi+ecx*4]	; 1 Clock cycle
	
	ret
GetCos endp

GetTan proc uses esi deg:dword						; 3 Clock cycle
	
	mov esi,SCTbl_tan					; 1 Clock cycle
	mov ecx,deg						; 1 Clock cycle
	mov eax,dword ptr[esi+ecx*4]	; 1 Clock cycle
	
	ret
GetTan endp

FPGetSin proc uses esi deg:dword					; 3 Clock cycle
	
	mov esi,FPU_SinTable			; 1 Clock cycle
	mov ecx,deg						; 1 Clock cycle
	mov eax,dword ptr[esi+ecx*4]	; 1 Clock cycle
	
	ret
FPGetSin endp

FPGetCos proc uses esi deg:dword					; 3 Clock cycle
	
	mov esi,FPU_CosTable			; 1 Clock cycle
	mov ecx,deg						; 1 Clock cycle
	mov eax,dword ptr[esi+ecx*4]	; 1 Clock cycle
	
	ret
FPGetCos endp

FPGetTan proc uses esi deg:dword					; 3 Clock cycle
	
	mov esi,FPU_TanTable			; 1 Clock cycle
	mov ecx,deg						; 1 Clock cycle
	mov eax,dword ptr[esi+ecx*4]	; 1 Clock cycle
	
	ret
FPGetTan endp


GetFG proc uses esi w:dword,deg:dword				; 129 Clock cycle
	
	
	invoke GetTan,deg					; 4 Clock cycle
	push eax							; 1 Clock cycle
		fld dword ptr[esp]				; 3 Clock cycle
		fidivr w						; 86 Clock cycle
		fistp dword ptr[esp]			; 34 Clock cycle
	pop eax								; 1 Clock cycle
	; 129 Clock cycle
	; eax= result
	ret
GetFG endp

UMGetSqrt proc uses esi value:dword
	; Gem writers: Arne Steinarson
	
		mov eax,value
		mov esi,sqrt_tbl
		
        cmp     eax,10000h
        jb      c_15_0
        cmp     eax,1000000h
        jb      c_23_16

; bit 31..24
        cmp     eax,10000000h
        jb      c_27_24
        cmp     eax,40000000h
        jb      c_29_28
        shr     eax,24
        mov     al, [esi+eax]
        shl     eax,8
        ret
c_29_28:
        shr     eax,22
        mov     al, [esi+eax]
        shl     eax,7
        ret
c_27_24:
        cmp     eax,4000000h
        jb      c_25_24
        shr     eax,20
        mov     al, [esi+eax]
        shl     eax,6
        ret
c_25_24:
        shr     eax,18
        mov     al, [esi+eax]
        shl     eax,5
        ret

; bit 23..16
c_23_16:
        cmp     eax,100000h
        jb      c_19_16
        cmp     eax,400000h
        jb      c_21_20
        shr     eax,16
        mov     al, [esi+eax]
        shl     eax,4
        ret
c_21_20:
        shr     eax,14
        mov     al, [esi+eax]
        shl     eax,3
        ret
c_19_16:
        cmp     eax,40000h
        jb      c_17_16
        shr     eax,12
        mov     al, [esi+eax]
        shl     eax,2
        ret
c_17_16:
        shr     eax,10
        mov     al, [esi+eax]
        shl     eax,1
        ret

c_15_0: cmp     eax,100h
        jb      c_7_0

; bit 15..8
        cmp     eax,1000h
        jb      c_11_8
        cmp     eax,4000h
        jb      c_13_12
        shr     eax,8
        mov     al, [esi+eax]
        ret
c_13_12:
        shr     eax,6
        mov     al, [esi+eax]
        shr     eax,1
        ret
c_11_8: cmp     eax,400h
        jb      c_9_8
        shr     eax,4
        mov     al, [esi+eax]
        shr     eax,2
        ret
c_9_8:  shr     eax,2
        mov     al, [esi+eax]
        shr     eax,3
        ret

;bit 7..0
c_7_0:  cmp     eax,10h
        jb      c_3_0
        cmp     eax,40h
        jb      c_5_4
        mov     al, [esi+eax]
        shr     eax,4
        ret
c_5_4:  shl     eax,2
        mov     al, [esi+eax]
        shr     eax,5
        ret
c_3_0:  cmp     eax,4h
        jb      c_1_0
        shl     eax,4
        mov     al, [esi+eax]
        shr     eax,6
        ret
c_1_0:  shl     eax,6
        mov     al, [esi+eax]
        shr     eax,7
        ret	
	ret
UMGetSqrt endp


; iNumber maximum is 3600
flGenerateReal4 proc uses esi iNumber:dword
	
	mov esi,angle_tbl
	mov ecx,iNumber
	
	mov eax,[esi+ecx*4]
	
	ret
flGenerateReal4 endp

flGenerateReal8 proc uses esi lpvalue:dword,iNumber:dword
	
	mov esi,angle_tbl
	mov ecx,iNumber
	
	fld dword ptr[esi+ecx*4]
	mov eax,lpvalue
	fstp qword ptr[eax]
	
	ret
flGenerateReal8 endp

flGenerateReal4InPersent proc uses esi lpvalue:dword,iNumber:dword
	
	mov esi,angle_tbl
	mov ecx,iNumber
	
	mov eax,lpvalue
	
	fld dword ptr[esi+ecx*4]
	mov ecx,100
	fdiv dword ptr[esi+ecx*4]
	fstp dword ptr[eax]
	
	
	ret
flGenerateReal4InPersent endp

flGenerateReal8InPersent proc uses esi lpvalue:dword,iNumber:dword
	
	mov esi,angle_tbl
	mov ecx,iNumber
	
	mov eax,lpvalue
	
	fld dword ptr[esi+ecx*4]
	mov ecx,100
	fdiv dword ptr[esi+ecx*4]
	fstp qword ptr[eax]
	
	
	ret
flGenerateReal8InPersent endp


; dword floating value
flAddReal4 proc uses esi value:dword,iNumber:dword
	
	mov esi,angle_tbl
	mov ecx,iNumber
	
	push value
		fld dword ptr[esp]
		fadd dword ptr[esi+ecx*4]
		fstp dword ptr[esp]
	pop eax
	
	ret
flAddReal4 endp ; eax=value+iNumber

flSubReal4 proc uses esi value:dword,iNumber:dword
	
	mov esi,angle_tbl
	mov ecx,iNumber
	
	push value
		fld dword ptr[esp]
		fsub dword ptr[esi+ecx*4]
		fstp dword ptr[esp]
	pop eax	
	
	ret
flSubReal4 endp

flMulReal4 proc uses esi value:dword,iNumber:dword
	
	mov esi,angle_tbl
	mov ecx,iNumber
	
	push value
		fld dword ptr[esp]
		fmul dword ptr[esi+ecx*4]
		fstp dword ptr[esp]
	pop eax	
	
	
	ret
flMulReal4 endp

flDivReal4 proc uses esi value:dword,iNumber:dword
	
	mov esi,angle_tbl
	mov ecx,iNumber
	
	push value
		fld dword ptr[esp]
		fdiv dword ptr[esi+ecx*4]
		fstp dword ptr[esp]
	pop eax	
	
	ret
flDivReal4 endp

; quad floating value
flAddReal8 proc uses esi edi value:dword,iNumber:dword
	
	mov esi,angle_tbl
	mov ecx,iNumber
	
	mov edi,value
		fld qword ptr[edi]
		fadd dword ptr[esi+ecx*4]
		fstp qword ptr[edi]
	
	ret
flAddReal8 endp ; eax=value+iNumber

flSubReal8 proc uses esi edi value:dword,iNumber:dword
	
	mov esi,angle_tbl
	mov ecx,iNumber
	mov edi,value
		fld qword ptr[edi]
		fsub dword ptr[esi+ecx*4]
		fstp qword ptr[edi]
	
	ret
flSubReal8 endp

flMulReal8 proc uses esi edi value:dword,iNumber:dword
	
	mov esi,angle_tbl
	mov ecx,iNumber
	mov edi,value
		fld qword ptr[edi]
		fmul dword ptr[esi+ecx*4]
		fstp qword ptr[edi]
	
	
	ret
flMulReal8 endp

flDivReal8 proc uses esi edi value:dword,iNumber:dword
	
	mov esi,angle_tbl
	mov ecx,iNumber
	mov edi,value
	
		fld qword ptr[edi]
		fdiv dword ptr[esi+ecx*4]
		fstp qword ptr[edi]
	
	ret
flDivReal8 endp